;------------------------------------------------------------------------------
; File Name :      asr.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.01
;      Date:      Aug 25, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; Software interrupt driven Asynchronous Serial Receiver
;------------------------------------------------------------------------------
; Implementation is based in INT0 interrupt and uses TMR1 for timing bits
; Supported speed depends on software interrupt latency.
; Option to implement: use T1G for starting start-bit timing
; This will allow longer software latency

#define __asr_inc
#ifndef __vos_inc
    include "vos.inc"
#endif

 ifdef __asr_asm
   implementation
 else
   interface
 endif

 constant ASR.cMsgIDGotByte = 0F4h

 ; ASR configuration, static parameters
 variable ASR.cSPACE_Level  = .1
 variable ASR.Port          = GPIO
 variable ASR.Pin           = GP2       ; INT == GP2
 variable ASR.Tris          = TRISIO
 variable ASR.INTCON        = INTCON
 variable ASR.Baudrate      = .2400
 ; enum ASR.cReceiver (External, Internal, Broadcast) 
 constant ASR.eExternal     = .0    ; Application must provide ASR.Reciver object handle
 constant ASR.eInternal     = .1    ; ASR will instantiate encapsulated object
 constant ASR.eBroadcast    = VOS_cBCastID
 variable ASR.cReceiver     = ASR.eExternal
;ASR.cReceiver     = ASR.eInternal
