;------------------------------------------------------------------------------
; File Name :      asr_m.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.01
;      Date:      Aug 25, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; Internal macros for software interrupt driven Asynchronous Serial Receiver
;------------------------------------------------------------------------------

asr_mLoadTMR1 macro int16
    local p = int16 & 0FFFFh
        movlw       high p
        movwf       TMR1H
        movlw       low p
        movwf       TMR1L
 endm

asr_mAddTMR1 macro int16
    local p = int16 & 0FFFFh
        ; [!] may not be proper for 16-bit write operation 
        movlw       low p
        addwf       TMR1L, F
        movlw       high p
        skpnc
        addlw       .1
        movwf       TMR1H
 endm

asr_mReadBit macro
        setc
    if ASR.cSPACE_Level == .0
        btfss    ASR.RX
    else
        btfsc    ASR.RX
    endif
        clrc
 endm

asr.mSetEdge macro
        _sfr_banksel OPTION_REG
    if ASR.cSPACE_Level == .0
        bcf     OPTION_REG, INTEDG  ; falling edge
    else
        bsf     OPTION_REG, INTEDG  ; raisng edge
    endif
 endm

