;------------------------------------------------------------------------------
; File Name :     main.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.00
;      Date:      Dec 5, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
; Utilitary macros
;------------------------------------------------------------------------------
INDF_movff macro fsr, dst, len
    local i
    while i < len
        incf        FSR, F
        movff       INDF, dst+i
i++
    endw    
 endm

INDF_mLoadConstWord macro const
        incf        FSR, F
        movlw       low const
        movwf       INDF
        incf        FSR, F
        movlw       high const
        movwf       INDF
 endm


INDF_mAddConstWord macro const
        movlw       low const
        addwf       INDF, F
        movlw       high const
        skpnc
        addlw       .1
        incf        FSR, F
        addwf       INDF, F
 endm

INDF_mAddWord  macro gpr
        movfw       gpr
        addwf       INDF, F
        movfw       gpr + .1
        skpc
        addlw       .1
        incf        FSR, F
        addwf       INDF, F
 endm

INDF_mSetWordPlusConst macro gpr, const
        movfw       gpr
        addlw       low const
        movwf       INDF
        movlw       high const
        skpnc
        addlw       .1
        addwf       gpr+.1,W
        incf        FSR, F
        movwf       INDF
 endm
